import "./style.css";
import { computed as F, resolveComponent as O, createElementBlock as P, openBlock as m, Fragment as q, renderList as Q, withDirectives as W, normalizeClass as z, unref as f, createElementVNode as j, normalizeStyle as Z, createCommentVNode as A, createBlock as R, withModifiers as ee, renderSlot as ne, mergeProps as te, vShow as oe, ref as ae, reactive as H, withCtx as G, createVNode as V, toDisplayString as re, onActivated as se, onDeactivated as ie, watch as ce, nextTick as le } from "vue";
import { SvgButton as de, PluginPanel as ue } from "@opentiny/tiny-engine-common";
import { constants as ge } from "@opentiny/tiny-engine-utils";
import { useCanvas as S, useMaterial as pe, useLayout as X, useMessage as he } from "@opentiny/tiny-engine-meta-register";
import { extend as fe } from "@opentiny/vue-renderless/common/object";
const J = (p, i) => {
  const d = p.__vccOpts || p;
  for (const [r, _] of i)
    d[r] = _;
  return d;
}, me = ["draggable", "onClick", "onMouseenter", "onDragstart", "onDragover", "onDragenter"], be = {
  key: 0,
  class: "expand-icon"
}, ve = {
  __name: "DraggableTree",
  props: {
    data: {
      type: Array,
      default: () => []
    },
    active: {
      type: String
    },
    idKey: {
      type: String,
      default: "id"
    },
    labelKey: {
      type: String,
      default: "label"
    },
    childrenKey: {
      type: String,
      default: "children"
    },
    draggable: {
      type: Boolean,
      default: !1
    },
    disallowDrop: {
      type: Function,
      default: () => !1
    }
  },
  emits: ["click", "mouseenter", "drop"],
  setup(p, { emit: i }) {
    const d = p, r = (e) => {
      const { idKey: o, labelKey: s, childrenKey: a } = d, h = e[o], x = e[s], D = e[a], l = { id: h, label: x, rawData: e };
      return Array.isArray(D) && (l.children = D.map((M) => r(M))), l;
    }, _ = (e) => Array.isArray(e) ? e.map((o) => r(o)) : [], k = F(() => _(d.data)), b = () => {
      const e = ae({});
      return { collapseMap: e, setCollapse: (a, h) => {
        e.value[a] = h;
      }, switchCollapse: (a) => {
        e.value[a] = !e.value[a];
      } };
    }, { collapseMap: v, setCollapse: I, switchCollapse: B } = b(), y = (e, o, s = 0, a = !1) => {
      const { children: h, ...x } = e, D = (h || []).map((M) => y(M, e.id, s + 1, a || v.value[e.id])).flat(), l = {
        ...x,
        parentId: o,
        level: s,
        hasChildren: (h == null ? void 0 : h.length) > 0,
        collapsed: a
      };
      return D.forEach((M) => {
        M.parent || (M.parent = l);
      }), [l].concat(D);
    }, g = (e) => y({ children: e }, null, -1).slice(1), T = F(() => g(k.value)), L = i, Y = (e) => {
      L("click", e);
    }, U = (e) => {
      L("mouseenter", e);
    }, n = () => {
      const e = { dragged: null, hovering: null, position: "", borderClass: "", forbidInsert: !1 }, o = H({ ...e });
      return { draggingState: o, resetDraggingState: () => {
        Object.assign(o, e);
      } };
    }, { draggingState: t, resetDraggingState: c } = n(), u = (e, o) => {
      d.draggable && (e.dataTransfer.setDragImage(new Image(), 0, 0), t.dragged = o, o.hasChildren && I(o.id, !0));
    }, C = (e) => {
      const o = e.currentTarget.getBoundingClientRect(), s = e.clientY - o.top, a = 8;
      return s <= a ? { position: "top", borderClass: "border-top" } : s >= o.height - a ? { position: "bottom", borderClass: "border-bottom" } : { position: "center", borderClass: "border-all" };
    }, N = (e, o) => {
      if (!d.draggable)
        return;
      const s = C(e);
      if (o.id === T.value[0].id && s.position !== "center") {
        e.preventDefault();
        return;
      }
      if (d.disallowDrop({ dragged: t.dragged, target: o, position: s.position })) {
        Object.assign(t, { ...s, hovering: o, forbidInsert: !0 });
        return;
      }
      e.preventDefault(), Object.assign(t, { ...s, hovering: o, forbidInsert: !1 });
    }, w = () => {
      if (!d.draggable || t.forbidInsert)
        return;
      const { dragged: e, hovering: o, position: s } = t;
      L("drop", { dragged: e, target: o, position: s });
    }, K = () => {
      c();
    }, E = (e) => {
      if (!d.draggable)
        return;
      const o = e.currentTarget.getBoundingClientRect(), s = 4;
      (e.clientX <= o.left + s || e.clientX >= o.right - s || e.clientY <= o.top + s || e.clientY >= o.bottom - s) && Object.assign(t, { hovering: null });
    };
    return (e, o) => {
      const s = O("svg-icon");
      return m(), P("div", {
        class: "draggable-tree",
        onDragleave: E
      }, [
        (m(!0), P(q, null, Q(T.value, (a) => {
          var h, x, D;
          return W((m(), P("div", {
            key: a.id,
            class: z([
              "tree-row",
              "flex-center",
              {
                active: p.active === a.id,
                dragging: ((h = f(t).hovering) == null ? void 0 : h.id) === a.id,
                "border-all": ((x = f(t).hovering) == null ? void 0 : x.id) === a.id && f(t).position === "center",
                forbid: f(t).forbidInsert
              }
            ]),
            draggable: p.draggable ? "true" : void 0,
            onClick: (l) => Y(a),
            onMouseenter: (l) => U(a),
            onDragstart: (l) => u(l, a),
            onDragover: (l) => N(l, a),
            onDragenter: (l) => N(l, a),
            onDrop: w,
            onDragend: K
          }, [
            j("div", {
              class: "content flex-center",
              style: Z({ paddingLeft: `${12 * a.level}px` })
            }, [
              a.hasChildren ? A("", !0) : (m(), P("span", be)),
              a.hasChildren ? (m(), R(s, {
                key: 1,
                name: "dropdown",
                class: z(["expand-icon", { rotate: f(v)[a.id] }]),
                onClick: ee((l) => f(B)(a.id), ["stop"])
              }, null, 8, ["class", "onClick"])) : A("", !0),
              j("div", {
                class: z([
                  "slot-content",
                  "flex-center",
                  {
                    [f(t).borderClass]: ((D = f(t).hovering) == null ? void 0 : D.id) === a.id && f(t).position !== "center",
                    forbid: f(t).forbidInsert
                  }
                ])
              }, [
                ne(e.$slots, "content", te({ ref_for: !0 }, a), void 0, !0)
              ], 2)
            ], 4)
          ], 42, me)), [
            [oe, !a.collapsed]
          ]);
        }), 128))
      ], 32);
    };
  }
}, ye = /* @__PURE__ */ J(ve, [["__scopeId", "data-v-d1a48e9b"]]), { PAGE_STATUS: $ } = ge, De = {
  components: {
    PluginPanel: ue,
    SvgButton: de,
    DraggableTree: ye
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(p) {
    const { pageState: i } = S(), { getMaterial: d } = pe(), { PLUGIN_NAME: r } = X(), _ = F(() => {
      var n;
      return (n = p.fixedPanels) == null ? void 0 : n.includes(r.OutlineTree);
    }), k = (n) => {
      const t = (c) => (c.forEach((u) => {
        u.show = i.nodesStatus[u.id] !== !1, u.showEye = !u.show;
        const C = u.children;
        Array.isArray(C) && t(u.children);
      }), c);
      return [{ ...t([fe(!0, {}, n)])[0], componentName: "body", id: "body" }];
    }, b = H({
      pageSchema: [],
      isLock: F(
        () => ![$.Occupy, $.Guest].includes(X().layoutState.pageStatus.state)
      )
    }), { subscribe: v, unsubscribe: I } = he();
    return se(() => {
      b.pageSchema = k(i.pageSchema), v({
        topic: "schemaChange",
        subscriber: "node-tree",
        callback: ({ operation: n }) => {
          (n == null ? void 0 : n.type) !== "changeProps" && (b.pageSchema = k(i.pageSchema));
        }
      });
    }), ie(() => {
      I({
        topic: "schemaChange",
        subscriber: "node-tree"
      });
    }), ce(
      () => i.currentSchema,
      () => {
        const { getSchema: n } = S();
        b.pageSchema = k(n());
      }
    ), {
      panelFixed: _,
      eyeOpen: (n) => i.nodesStatus[n] !== !1,
      showNode: (n) => {
        n.show = !n.show, i.nodesStatus[n.id] = n.show;
        const { getRenderer: t, clearSelect: c } = S().canvasApi.value;
        t().setCondition(n.id, n.show), c();
      },
      state: b,
      PLUGIN_NAME: r,
      pageState: i,
      getIconName: (n) => (d(n.rawData.componentName).icon || "plugin-icon-page").toLowerCase(),
      handleClickRow: (n) => {
        const { selectNode: t } = S().canvasApi.value;
        t(n.id, "clickTree");
      },
      handleMouseEnterRow: (n) => {
        const { hoverNode: t } = S().canvasApi.value;
        t(n.id);
      },
      disallowDrop: ({ dragged: n, target: t, position: c }) => {
        if (n.id === "body")
          return !0;
        const u = c === "center" ? t : t.parent;
        if (u.id === "body")
          return !1;
        const { getConfigure: C, allowInsert: N } = S().canvasApi.value;
        return !N(C(u.rawData.componentName), n.rawData);
      },
      handleDrop: ({ dragged: n, target: t, position: c }) => {
        if (n.id === t.id || c === "center" && t.rawData.children.some((w) => w.id === n.id))
          return;
        if (c !== "center") {
          const w = t.parent.rawData.children, K = w.findIndex((e) => e.id === t.id), E = w[c === "top" ? K - 1 : K + 1];
          if (n.id === (E == null ? void 0 : E.id))
            return;
        }
        const { insertNode: u, removeNode: C, selectNode: N } = S().canvasApi.value;
        C(n.id), u(
          { data: n.rawData, node: t.rawData, parent: t.parent.rawData },
          c === "center" ? "in" : c
        ), le(() => {
          N(n.id, "clickTree");
        });
      }
    };
  }
}, Ce = { class: "row-content" };
function Se(p, i, d, r, _, k) {
  const b = O("svg-button"), v = O("svg-icon"), I = O("draggable-tree"), B = O("plugin-panel");
  return m(), R(B, {
    class: "outlinebox",
    title: "大纲树",
    onClose: i[1] || (i[1] = (y) => p.$emit("close"))
  }, {
    header: G(() => [
      V(b, {
        class: "item icon-sidebar",
        name: r.panelFixed ? "fixed-solid" : "fixed",
        tips: r.panelFixed ? "解除固定面板" : "固定面板",
        onClick: i[0] || (i[0] = (y) => p.$emit("fix-panel", r.PLUGIN_NAME.OutlineTree))
      }, null, 8, ["name", "tips"])
    ]),
    content: G(() => {
      var y;
      return [
        V(I, {
          "label-key": "componentName",
          data: r.state.pageSchema,
          draggable: !0,
          active: (y = r.pageState.currentSchema) == null ? void 0 : y.id,
          "disallow-drop": r.disallowDrop,
          class: "outline-tree",
          onClick: r.handleClickRow,
          onMouseenter: r.handleMouseEnterRow,
          onDrop: r.handleDrop
        }, {
          content: G((g) => [
            j("div", Ce, [
              r.getIconName(g) ? (m(), R(v, {
                key: 0,
                name: r.getIconName(g)
              }, null, 8, ["name"])) : A("", !0),
              j("span", {
                class: z(["row-label", { "node-isblock": g.rawData.componentType === "Block" }])
              }, re(g.label), 3),
              g.id !== "body" ? (m(), P(q, { key: 1 }, [
                r.eyeOpen(g.id) ? (m(), R(v, {
                  key: 0,
                  name: "eye",
                  onMouseup: (T) => r.showNode(g.rawData)
                }, null, 8, ["onMouseup"])) : A("", !0),
                r.eyeOpen(g.id) ? A("", !0) : (m(), R(v, {
                  key: 1,
                  name: "eye-invisible",
                  onMouseup: (T) => r.showNode(g.rawData)
                }, null, 8, ["onMouseup"]))
              ], 64)) : A("", !0)
            ])
          ]),
          _: 1
        }, 8, ["data", "active", "disallow-drop", "onClick", "onMouseenter", "onDrop"])
      ];
    }),
    _: 1
  });
}
const _e = /* @__PURE__ */ J(De, [["render", Se], ["__scopeId", "data-v-f5fa5922"]]), ke = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  align: "top"
}, Te = {
  ...ke,
  entry: _e
};
export {
  Te as default
};
